/*
 * example2.c -- \int_0^1 e^x dx
 *   cc example2.c
 *   ./a.out > ex2.data
 */

#include <stdio.h>
#include <math.h>
#include "nc.c"

double f(double x)
{
  return exp(x);
}

int main(void)
{
  int N;
  double a, b, If;
  double  M, T, S;
  a = 0.0; b = 1.0; If = exp(1.0) - 1;
  printf("#   N       I-M_N           I-T_N         I-S_N\n");
  for (N = 2; N <= 65536; N *= 2) {
    M = midpoint(f, a, b, N);
    T = trapezoidal(f, a, b, N);
    S = simpson(f, a, b, N);
    printf("%5d  %14e %14e %14e\n", N, If - M, If - T, If - S);
  }
  return 0;
}
