/*
 * example3.c -- \int_0^1 \sqrt{1-x^2} dx
 */

#include <stdio.h>
#include <math.h>
#include "nc.c"

double f(double x)
{
  return sqrt(1 - x * x);
}

int main(void)
{
  int N;
  double a, b, pi, I;
  double  M, T, S;
  a = 0.0; b = 1.0; pi = 4 * atan(1.0); I = pi / 4;
  printf("#   N       I-M_N           I-T_N         I-S_N\n");
  for (N = 2; N <= 65536; N *= 2) {
    M = midpoint(f, a, b, N);
    T = trapezoidal(f, a, b, N);
    S = simpson(f, a, b, N);
    printf("%5d  %14e %14e %14e\n", N, I - M, I - T, I - S);
  }
  return 0;
}
