/*
 * example4.c -- \int_0^{2\pi} \frac{1}{2+\cos x} dx
 */

#include <stdio.h>
#include <math.h>
#include "nc.c"

double f(double x)
{
  return 1.0 / (2.0 + cos(x));
}

int main(void)
{
  int N;
  double a, b, I, pi;
  double  M, T, S;
  pi = 4 * atan(1.0);
  a = 0.0; b = 2 * pi; I = 2 * pi / sqrt(3.0);
  printf("#   N       I-M_N           I-T_N         I-S_N\n");
  for (N = 2; N <= 65536; N *= 2) {
    M = midpoint(f, a, b, N);
    T = trapezoidal(f, a, b, N);
    S = simpson(f, a, b, N);
    printf("%5d  %14e %14e %14e\n", N, I - M, I - T, I - S);
  }
  return 0;
}
